# C++ Source Line Counter
# Author: (c) Martinov G.M.
# 31.05.2002 

$sourcePath = 'C:\NCSoft\TestXmlSpeed'; # value by default
$fileTypes = '(.h$)|(.cpp$)|(.c$)';     # value by default
$version = "0.0.2";
$silent = 0;

sub DirLoop             # parametr $_[0] is DirName
{
  opendir (CURRENT_DIR, $_[0])  
    or die "Cant open $_[0]:  $!";
  print "Open dir $_[0] \n"  if($silent == 0);
  
  # directory loop
  foreach $File (readdir CURRENT_DIR)  
  {
    if (-f "$_[0]/$File" && $File=~m/\w+$fileTypes/i)
    { # one of files
      open CURRENT_SOURCE, "$_[0]/$File" 
        or die "Can't open '$_[0]/$File' for readig; $!";
    
      $sourceLineCounter++    while(<CURRENT_SOURCE>); # read the file in the loop
      print "  read $_[0]/$File \n"  if($silent == 0);
      $sourceFilesCounter++;
    }
    elsif (-d "$_[0]/$File" && $File=~m/\w+/ )
    { # subdirectory
      &DirLoop("$_[0]/$File");
    }
  }
  closedir(CURRENT_DIR);
}

print "Source Line Counter version $version \n\n";
#------------ comand line argumentshandling
if ( $ARGV[0] eq '/?' || $ARGV[0] eq '|?')
{ # help call
  print "  command line: %perl SourceLineCounter2.pl [/?] [|?]\n"."or \n";
  print "              : %perl SourceLineCounter2.pl [SourcePath] [FileTypes] [-s]\n";
  print "  arguments: \n    [/?] or [|?] - this help\n";
  print "    [SourcePath] - path to source subdirectory\n    [FileTypes]  - file type to be calculated (delimeter is symol ':')\n";
  print "    [-s]         - silent\n\n";
  print "  exemple for analysing *.h and *.cpp files:\n    %perl SourceLineCounter2.pl $sourcePath *.h:*.cpp\n";
  $#ARGV = -1; 
  print "\n"."Press <Enter> to close";  
  exit if ( <> );
}
elsif ($#ARGV > -1)
{ # handling arguments for path and file type
  $sourcePath = $ARGV[0]    if (-d $ARGV[0]);
  
  @FileTypeArray = split(/:/, $ARGV[1]);
  foreach $TypeItem (@FileTypeArray)
  {
    $TypeItem =~ s/\*//;                # delete '*'
    $TypeItem = '('.$TypeItem.'$)';     # like (.h$)
  }
  $ARGV[1] = join('|', @FileTypeArray);
  $fileTypes = $ARGV[1]     if ($ARGV[1] ne ''); 
  
  $silent = 1   if ($ARGV[2] =~ m/^-s$/i);
  $#ARGV = -1;                          # clear arguments
}

#----------------------------
-e($sourcePath) or die " Directory $sourcePath doesn't exist  $!";
#print "Looking in directory: $sourcePath\n"."for files with extension: $fileTypes\n";
  
&DirLoop($sourcePath);

print "\n"."Source files: $sourceFilesCounter     Source lines: $sourceLineCounter \n\n";
print "End!  Press <Enter> to close"; <> 
